using System;
using System.Collections;
using System.Collections.Generic;

using jsonapi.Data;

using Microsoft.Extensions.Configuration;

namespace jsonapi.Library
{
	public class RoomGenerator
	{
		public static RoomGenerator GetInstance()
		{
			return new RoomGenerator(Startup.Configuration);
		}

		private IConfiguration configuration;

		public RoomGenerator(IConfiguration config) {
			configuration = config;
		}

		public dynamic Generate(int x, int y, int z)
		{
			//TODO:
			//pick random room(zone) size
			//generate random room rectangles that don't overlap
			//pull from "size pool" so total room percentage is < 60%
			//generate door nodes on room edges
			//generate random door nodes outside of rooms
			//connect door nodes based on proximity

			//place treasure
			//place monsters

			var random = new Random();

			var roomWidth = (int)Math.Floor((float)random.Next(24, 258) / 2);
			var roomHeight = (int)Math.Floor((float)random.Next(24, 182) / 2);

			var room = new Room{
				width = roomWidth,
				height = roomHeight,
				center = new Point{
					x = roomWidth / 2,
					y = roomHeight / 2
				},
				tileSize = new Size{
					width = 16,
					height = 16,
				}
			};
			var backgroundRegions = new ArrayList();
			var backgroundTiles = new Dictionary<int, Dictionary<int, int>>();
			backgroundTiles.Add(0, new Dictionary<int, int>());
			backgroundTiles.GetValueOrDefault(0).Add(0, 14);
			var body = new {
					room = room,
					backgroundRegions = backgroundRegions,
					backgroundTiles = backgroundTiles
				};
				return body;
		}
	}
}
